# IMPORTANT NOTE: FOLLOWING THE RELEASE OF 1.0, ARTIFICER EXTENDED IS NO LONGER DEPENDENT ON ALTERNATIVE ARTIFICER, AS LONG AS ALT ARTI IS DEPRECATED.

If you have any feedback or ideas, please contact me on Discord @duck duck grey duck#0658! Alternatively, you can put it into this google form https://forms.gle/PwdwL98AbTrVLsuKA!

Thanks to Tera on Discord for helping with icons!

## Mod Overview
ArtificerExtended introduces a handful of new skills for Artificer with the intention of adding new, varied gameplay styles in creative ways. This is built with compatability for AlternativeArtificer as a primary goal. Currently introduces 7 new abilities: SNOWBALLS, ICE SHARDS, CHANNEL NANO-METEOR, FOCUSED SHOCKWAVE, NAPALM CASCADE, ROLLING THUNDER, and FROSTBITE!

Additionally, this mod also gives slight buffs to a few of the underperforming parts of Artificer's base kit. They are as follows:
Snapfreeze - Base cooldown duration reduced from 12 seconds to 8.

## New Primary Skills: "Snowballs" and "Ice Shards"
Snowballs are an ICE m1 that, unlike her other bolts, are un-limited by cooldown. This means they can scale perfectly with attack speed - a great asset for lategame and ion surge users!

Ice Shards are another ICE m1 with a low range shotgun-like fire. This skill is designed for high risk, high reward play - it synergizes great with her other low range skills, like flamethrower, and the new Napalm!

Note: These skills DO contribute to the "ice" part of AlternativeArtificer's passive, however theyre unable to freeze + execute enemies on their own, so you will need to pick another ice skill to benefit from the ice passive. I am considering adding an additional way for these abilities to scale with the passive, at least until Rein updates AlternativeArtificer to accomodate for it.

## New Secondary Skills: "Channel Nano-Meteor" and "Focused Shockwave"
Nano-Meteor is a FIRE m2 that, unlike her other nanos, has no projectile or travel time. It casts and summons where you aim, offering a new approach to high damage combat. Charging Nano-Meteor increases it's AoE size, and increases the amount of hits it creates, applying multiple stacks of burn in an area.

Shockwave is a LIGHTNING m2 that is a completely unique option in the fact that it does not charge up like her other Secondaries. Instead, this ability provides a small amount of "offensive mobility", attached to a powerful AoE melee skill. It is a powerful asset for closing gaps and staying in the fight for an aggressive Artificer.

## New Utility Skills: "Napalm Cascade" and "Rolling Thunder"
Napalm Cascade is a FIRE alternative to snapfreeze. It sprays a cone of napalm puddles extending outwards from the player, with the ability to CHARGE IT UP (much like the charging of Nanobombs and Nanospears) to tune the spread. Much like the new Ice Shards, Napalm is intended to reward risky play styles, as well as synergizing with the outward piercing attacks of Flamethrower and Nanospears! Like Snapfreeze, it can be used either as a tool to maximize damage output, or for area denial.

Note: The Napalm "burn" scales damage per tick with the "fire" part AlternateArtificer's passive.

Rolling Thunder is a LIGHTNING utility, which is uniquely capable of targeting aerial enemies. It presents an alternative with snapfreeze, offering more controlled damage and stuns on demand. Thunder's charge system allows the choice to either use strikes as they come off cooldown, or save them up to stunlock a target for a longer time.

## New Special Skill: "Frostbite"
Frostbite is an ICE special, who offers a third polarizing option for Artificer's playstyle: Defense! On cast, you gain an armor and speed boost, accompanied by ice novas which encourage you to use the defense to play more aggressively. Because the ice novas fire passively, Frostbite synergizes particularly well with charged skills, as you can combo a full charge with a radial freeze.

## Known Issues:
- Frostbite's secondary nova does not work for clients in a multiplayer game as of 2.0.0 
- Shockwave's shockwave does not deal damage for clients in a multiplayer game as of 2.0.0
(*Needs testing for updates 2.0.3 and higher; potentially fixed)

## Changelog
### 2.0.5
```
	Nano-Meteor:
- Changed reticle spread bloom to now increase in intervals rather than smoothly

	Other: 
- Changed the order of Ice Shards and Snowballs in preparation for a future update
- Fixed a horrible formatting error in the changelog that broke the entire dang thing
- Extended Artificer's head by 8%
```

### 2.0.4
```
	Shockwave:
- Fixed new Shockwave damage and range values to (hopefully?) match the old version
```

### 2.0.3: Polish and Stuff
```
	Bug fixes:
- Hopefully maybe fixed Shockwave not properly attacking in Multiplayer?
- Hopefully maybe fixed Frostbite not properly adding the Frostbite buff (and consequently not creating the 2nd nova) in Multiplaer?

	Ice Shards:
- Increased buckshot count (2 -> 3)
- Increased buckshot MINIMUM spread fraction (1/5 -> 1/3)
- Reduced max spread (0.6 -> 0.4)
- Increased total damage coefficient (500% -> 540%)

	Nano-Meteor:
- Reduced Meteor VFX scale (3 -> 2)
- Changed falloff model (SweetSpot -> None)

	Napalm:
- Increased Decal scale (3 -> 3.5)
- Increased "burn" tick damage (5 -> 8.5)
(*Ive noticed Napalm has been feeling a lot weaker since 1.0,
this should hopefully help.)
- Max spread increased (8.5 -> 10)
- Max yaw increased (20 -> 25)

	Shockwave:
- Reduced total attack duration (1s -> 0.75s)
- Reduced blink duration (0.25s -> 0.2s)
- Increased blink speed (6 -> 7)
(*I didnt want the mobility of Shockwave getting in the way of combat. 
This should help fix it.)
- VFX updated, processing streamlined

	Frostbite:
- Primary blast radius reduced (20m -> 15m)
(This was mainly to keep both aoes consistent in size, 
hopefully helping to make it more intuitive)

	Other:
- Made minor adjustments to the mod icon 
(mostly because i didnt save the original 2.0 version and had to remake it)
- Extended Artificer's head length by another 6.9%
```

### 2.0.2: Bugfixes and Stuff
```
	Bug fixes:
- Fixed Shockwave blink distance reducing with attack speed; 
now increases blink speed while reducing blink duration to keep distance consistent
- Fixed Frostbite primary nova not using the correct damage, range, or proc coefficient values

	Snowballs:
- Damage increased (140% -> 175%)

	Meteor:
- Added config option to disable meteor recoloring

	Shockwave:
- Reduced blink speed (7.5 -> 6)
- Tweaked ingame description to more clearly describe the sequence of effects

	Frostbite:
- Made the Frostbite buff stackable; stacking does not increase the movespeed or armor buff
- Secondary nova now triggers after each stack expires
- Reduced armor increase from the Frostbite buff (200 -> 150)
- Reduced force on primary nova (2000 -> 1500)

	Other:
- Added some missing information in the README, namely a Shockwave description, certain credits, and dependencies
- Extended Artificers head length by 6%
```

### 2.0.1
```
	Meteor:
- Fixed meteor firing 60 explosions instead of 6
```

### 2.0.0: Mostly icons and stuff, also 2 new abilities which is a little neat but nothing to run home about i guess
```
	New:
- Added "FOCUSED SHOCKWAVE" lightning secondary
- Added "FROSTBITE" ice special
- Added all missing icons for ArtificerExtended skills
- Updated icons for Snowball and Ice Shards
- Added Keywords and fixed formatting in ability descriptions
- Removed AlternateArtificer dependency... for now

	Ice Shards:
- Reduced shard spread (0.7 -> 0.6)
- Increased bullet width (?? -> 0.15)
- Increased proc coefficient for all shards (0.9 for buckshot, 0.7 for everything else)
- Improved firing SFX

	Nano-Meteor:
- Increased max Meteor count (4 -> 6)
- Reduced Meteor damage (400% -> 200%)
(*With the shift in balance from 1.0, Ive decided to cement Meteor as more of a multi-hit option,
as opposed to all the other Secondary skills being heavy single hits)
- Reduced delay between meteors by 20%
- "Fixed" VFX colors

	Napalm:
- Reduced burn tick frequency (2 -> 1.5)
- Increased burn tick damage (2.5 -> 5)
(*Crits with Shatterspleen would create A LOT of bleed ticks, this should reduce it a slight amount)
- Reduced max charge duration (3s -> 2s)
- Increased AlternateArtificer passive tick frequency (1 per 0.75s -> 0.5s)
- Increased max spread (7.5 -> 8.5)
- Removed scaling damage with charge; now charging only tunes cone of fire

	Thunder:
- Increased total damage (600% -> 750%)
- Reduced starting velocity (23 -> 17.5)
- Reduced max angle (10 -> 7.5)
- Increased projectile size (0.1 -> 0.2)
- Reduced AoE size (7 -> 6)
- Fixed sprint canceling to act more like Snapfreeze
- Fixed misinformation in the ability description

	Other: 
- Removed Plasma Bolt changes, as they are now redunant with their buff from 1.0
- Reduced snapfreeze cooldown back to 8 again.
- Extended Artificer head length by 5%
```

### 1.5.0: Ice Shards 2.0
```
	Ice Shards:
*Added more nuance to the firing system of Ice Shards
*Now has one Bullet which always fires straight forward, for slightly more consistency
*Added "buckshot" which is less accurate and has stronger falloff, but rewards close combat

- Total Bullet count increased (3 -> 5)
- Total damage increased (420% -> 500%)
- Overall proc coefficient reduced (0.6 for all -> 0.4, 0.5, and 0.6 for different Bullet types)
- Increased Bullet width (0 -> 0.15)
- Now rolls for crit on cast instead of for each bullet
- Added Icon

	Snapfreeze:
- Cooldown brought back down to 8s
	
	Meteor:
- Renamed to Channel Nano-Meteor
- AoE radius reduced from (3 to 6 -> 2 to 5)
- Force increased (750 -> 1000)

	Napalm:
- Changed projectile spread calculations 
(now has min and max values that change based on charge progress)
- Crosshair now starts at max size and shrinks with charge to reflect the focusing cone

	Thunder:
- Reduced total damage back down to 600%
(*Yeah...)

	Other:
- Artificer head length extended by 4%
```

### 1.4.2
```
	Snowballs:
- Proc coefficient increased (0.7 -> 1.0)
- Attack duration reduced (0.8 -> 0.7)
- Damage reduced (220% -> 140%)

	Ice Shards:
- Reduced recoil amplitude (2.5 -> 1.5)

	Thunder:
- Reduced max charges (3 -> 2)
- Increased damage back up to 750%
(*As it turns out, my issue with damage was moreso with its high burst when you save up Thunders, 
so with this change burst potential is quite greatly reduced 
and as such I brought the damage potential back up.)

	Other:
- Reformatted Thunderstore patch notes
- Artificer head length increased by 0.02%
```
### 1.4.1: Plasma Bolt Buff
```
	Meteor:
- Now rolls for crit on cast rather than individually for each meteor
- Removed some debug messages I left in when casting (sorry for spamming your output logs lol)

	Napalm:
- Increased Napalm impact damage (200-400% -> 400-600%)
(*Napalm didnt feel very satisfying to use very offensively by casting ON an enemy, 
I found myself using it more proactively and defensively than I had intended when I was designing it.
This damage boost should help alleviate that.)

	Other:
- Increased Plasma Bolt aoe radius (4 -> 5)
- Rearranged formatting in the Thunderstore description
- Extended Artificers head by another WHOPPING 10.2%! The biggest increase yet!
```

### 1.4.0: Nano-Meteor
```
	NEW:
- Added "FOCUS NANO-METEOR" fire utility

	Napalm:
- Added short delays between each Napalm shot to make it feel approx 13% cooler

	Thunder:
- Fixed a bug where Thunder was creating children projectiles when its not supposed to

	Other:
- Updated mod description
- Fixed some more Thunderstore misinformation
- Further extended Artificers head length by 7.1%
```

### 1.3.2
```
	Thunder:
- Reduced Thunder damage back down to 600%, but removed damage falloff
(* In hindsight, having 750% damage near-guaranteed on an instant-cast attack was not a great idea, and definitely not in line with Snapfreeze)
- Slightly reduced the height at which Thunder bolts spawn above their target location
(*This should make it easier to hit small targets directly.)
- Increased Rolling Thunder proc coefficient (0.5 -> 0.6)
- Expanded the Thunder bolt cone of fire
- Reduced attack duration (0.5s -> 0.3s)

	Napalm:
- Reduced Napalm projectile count
- Reduced Napalm "burn" tick damage (3 -> 2)

	Other:
- Increased Snapfreeze cooldown back up to 10
- Fixed yet another naming error on Thunderstore
- Extended Artificers head by another 5.2%
```

### 1.3.1 
```
	Thunder:
- Reduced cooldown (6 -> 5)
- Increased total damage (600% -> 750%)
(* These changes are specifically to help keep it in line with Snapfreeze, as I made these values to match Snapfreeze before I buffed it)
- Reduced Thunder bolt initial velocity (35 -> 23). 
(*This reduces air time (it makes them come back down sooner))

	Other:
- Artificers head length has been increased by another 3%
```

### 1.3.0: Rolling Thunder 2.0 & Snapfreeze Buff
```
	Thunder:
- Reworked Rolling thunder. It now has 3 total projectiles, and double the total damage. Approximately 312.7% cooler.

	Other:
- Snapfreeze cooldown reduced (12s -> 8s). 
(*This should make it easier to create and balance new utilities without having to neuter them for the sake of "sidegrading" Snapfreeze.)
- Fixed all kinds of Thunderstore formatting and information issues.
- Artificers head is 10% longer.
```

### 1.2.1
```
	Snowball:
- Changed Snowball velocity (40 -> 80)
(*Snowballs now match the velocity of firebolts and plasmabolts)
```

### 1.2.0: Rolling Thunder
```
	New:
- Added "ROLLING THUNDER" lightning utility

	Napalm:
- Further reduced Napalm "burn" tick damage (5 -> 3)

	Other:
- Fixed a few errors regarding networking
- Updated Thunderstore formatting in some spots
```

### 1.1.1
```
	Napalm:
- Renamed to Napalm Cascade
- Reduced projectile count (15 -> 12)
- Increased AOE/decal size (2 -> 3)
- Reduced "burn" tick proc coefficient to 0
- Increased impact proc coefficient (0.5 -> 0.6)
```

### 1.1.0: Napalm Barrage and Ice Shards
```
	NEW:
- Added "NAPALM BARRAGE" fire utility
- Added "ICE SHARDS" ice primary

	Snowball:
- Added clarification to the effects of snowballs on the AlternateArtificer passive

	Other:
- Updated mod thumbnail + description
- Removed CLAPFREEZE (Rest In Peace, You Will Remain Forever In Our Hearts)
```

### 1.0.0: First release
```
- Introduced SNOWBALLS and CLAPFREEZE
```
